/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* int_symbz scicos Symbol Integrator memory
 * Type 4 simulation function ver 1.0 - scilab-3.0
 * 20 Mars 2009 Author : - INRIA - A.Layec
 */


#include <scicos/scicos_block.h>
#include "modnum_lib.h"

/* Entre rgulire : u1[0..nu*mu] : entre de l'intgrateur discret
/*                    u2[0..nu*mu] : sortie de l'intgrateur discret
 * Sortie rgulire : y[0..2*mu] : tat de l'intgrateur discret
 * Entre vnementielle : ( la rigueur)
 * Sortie vnementielle : nant
 *
 * Etat discret : z[0..2*mu] : tat de l'intgrateur discret
 *
 */

/*prototype*/
void int_symbz(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  double *u2;
  double *z;
  int nu;
  int mu=1; /* */
  int i;

  /*Rcupration des adresses des ports rguliers*/
  y  = (double *)block->outptr[0];
  u  = (double *)block->inptr[0];
  u2 = (double *)block->inptr[1];
  z  = (double *)block->z;

  /*Rcupration du nombre d'chantillons*/
  nu     = block->insz[0];
  mu     = block->insz[2];

  /*initialisation*/
  if((flag==4)||(flag==2)) {
    intsymz_c(&nu,&mu,u,u2,z);
  }
  /*calcul des sorties*/
  else if((flag==1)||(flag==6)) {
    copyd_c(&mu,z,y);
  }
}
