/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* fmodulo Scicos float modulo function
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 19 octobre 2003 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include<math.h>

#include "machine.h"

/* Cette fonction de simulation ralise la fonction non-lineaire
 * modulo sur des nombres dfinis en virgule flottante.
 * y=u-0.5*m-m*floor( (u-0.5m) / m)-0.5*m
 * entres rgulires : vecteur des entres u[0..nu-1]
 *
 * sorties rgulires : vecteur des sorties y[nu..2nu-1]
 * paramtres : rpar[0..nu-1] : m : vecteur des amplitudes
 * entres d'venement : nant
 * sorties d'venement : nant
 *
 * rmq : la sortie est soit positive soit ngative
 */

/*prototype*/
void fmodulo(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
             ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
 /*dclaration des variables*/
 int i,nu;
 double *y;
 double *u;

 /*Rcupration des adresses des ports rguliers*/
 y=(double *)outptr[0];
 u=(double *)inptr[0];

 /*Rcupration de la taille du port d'entre*/
 nu=insz[0];

 /*Calcul de la valeur modulo et place dans le registre de sortie*/
 for(i=0;i<nu;i++)
      y[i] = (u[i]-0.5*rpar[i])-rpar[i]*floor((u[i]-0.5*rpar[i])/rpar[i])-0.5*rpar[i];
}
