/* Modnumlib Scicos interfacing function
 * Copyright (C) 2009 Alan Layec
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
/* inserzerovec Scicos vectorial zero instertion
 * Type 4 simulation function ver 1.0 - scilab-2.6&2.7
 * 4 janvier 2005 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include <scicos/scicos_block.h>
#include "modnum_lib.h"


/* Cette fonction transforme un vecteur de taille Nu en un vecteur
 * de taile Ny, avec Ny>Nu, et en ajoutant des zros dans l'espace > Nu
 *
 * Entre rgulire  : u[0..nu-1] : vecteur d'entre de taille nu
 * sorties rgulire : y[0..ny-1] : vecteur de sortie de taille ny
 */

/*prototype*/
void inserzerovec(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  int i,nu,ny,k;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];

  /*Rcupration des tailles des ports rguliers*/
  nu=block->insz[0];
  ny=block->outsz[0];

  /*recopie u[] dans y[]*/
  copyd_c(&nu,&u[0],&y[0]);

  /*ajoute les zros*/
  for(i=nu;i<ny;i++) y[i]=0;
}
